import jp.jig.jiglet.*;

public class StopWatch extends Jiglet {
	long startTime;
	int[] lapTime;
	int lapNum = 0;
	int countTime = 0;
	int drawOffset = 0;
	
	public void main() {
		if (lapTime == null) {
			lapTime = new int[30];
			lapNum = 0;
			setTitle("STOP WATCH");
			countTime = 0;
			startTime = 0;
		}
		clearKey();
		
		for (;;) {
			int key = -1;
			if (startTime == 0) {
				if (countTime == 0) {
					setSoftLabel("END");
				} else {
					setSoftLabel("RESET");
				}
				repaint();
				sleep(60);
				
				key = getKey();
				
				if (key == KEY_SELECT) {
					startTime = currentTime();
				}
				if (key == KEY_SOFT) {
					if (countTime == 0) {
						terminate();
					}
					countTime = 0;
					lapNum = 0;
					drawOffset = 0;
				}
			} else {
				setSoftLabel("LAP");
				repaint();
				sleep(10);
				
				key = getKey();
				
				if (key == KEY_SELECT) {
					countTime = countTime + (int)(currentTime() - startTime);
					startTime = 0;
				}
				if (key == KEY_SOFT && lapNum < lapTime.length) {
					lapTime[lapNum] = countTime + (int)(currentTime() - startTime);
					lapNum++;
					drawOffset++;
				}
			}
			if (key == KEY_UP) {
				drawOffset--;
			}
			if (key == KEY_DOWN) {
				drawOffset++;
			}
			if (drawOffset >= lapNum - 15) {
				drawOffset = lapNum - 15;
			}
			if (drawOffset < 0) {
				drawOffset = 0;
			}
		}
	}
	
	public void paint(boolean allDrawFlag) {
		setFont(0);
		
		setColor(getColor(255, 255, 255));
		fillRect(0, 0, DW, DH);
		
		setColor(getColor(0, 0, 0));
		if (startTime == 0) {
			drawTime(countTime, 20, 20);
		} else {
			int def = countTime + (int)(currentTime() - startTime);
			drawTime(def, 20, 20);
		}
		drawLine(0, 25, DW, 25);
		int y = 30;
		for (int i = drawOffset; i < lapNum; i++) {
			int j = i + 1;
			drawString("LAP" + (j / 10) + (j % 10), 20, y + 12);
			drawTime(lapTime[i], 60, y + 12);
			if (i > drawOffset) {
				int def = lapTime[i] - lapTime[i - 1];
				drawString("+", 140, y + 5);
				drawTime(def, 146, y + 5);
			}
			y += 14;
			if (y >= DH) {
				break;
			}
		}
	}
	void drawTime(int time, int x, int y) {
		int hour = time / (60 * 60 * 1000);
		time -= hour * (60 * 60 * 1000);
		int min = time / (60 * 1000);
		time -= min * (60 * 1000);
		int sec = time / 1000;
		time -= sec * 1000;
		time /= 10;
		
		StringBuffer sb = new StringBuffer();
		sb.append(hour / 10);
		sb.append(hour % 10);
		sb.append(':');
		sb.append(min / 10);
		sb.append(min % 10);
		sb.append(':');
		sb.append(sec / 10);
		sb.append(sec % 10);
		sb.append(':');
		sb.append(time / 10);
		sb.append(time % 10);
		
		drawString(sb.toString(), x, y);
	}
}
